-- Mountaineers v0.1A

require('mathf')
require('plat')
require('playercontroller')

debug = false

function love.load()
	love.physics.setMeter(64)
	world = love.physics.newWorld(0, 9.81*64, true)
	love.graphics.setBackgroundColor(1,1,1)
	
	plat.new('Main', 0, love.graphics.getHeight()/2, love.graphics.getWidth(), love.graphics.getHeight(), {0,0,0})
	plat.new('Main', 0, 100, 100, 7, {0,0,0})
	
	pc.load()
end

function love.update(dt)
	world:update(dt)
	pc.update(dt)
	if debug then print(1/dt) end
end

function love.keypressed(key)
	pc.keypressed(key)
	
	if key == "p" then
		debug = not debug
	end
end

function love.draw()
	plat.draw('Main')
	pc.draw()
	
	if debug then
	love.graphics.setColor(1,0,0)
	love.graphics.print(love.timer.getFPS())
	for _, body in pairs(world:getBodies()) do
    for _, fixture in pairs(body:getFixtures()) do
        local shape = fixture:getShape()
 
        if shape:typeOf("CircleShape") then
            local cx, cy = body:getWorldPoints(shape:getPoint())
            love.graphics.circle("line", cx, cy, shape:getRadius())
        elseif shape:typeOf("PolygonShape") then
            love.graphics.polygon("line", body:getWorldPoints(shape:getPoints()))
        else
            love.graphics.line(body:getWorldPoints(shape:getPoints()))
        end
    end
	end
	end
end