-- Mathf v0.1

mathf = {}

function mathf.PingPong(t, length)

	-- t: time.time length: 5
	l = 2 * length -- 10
	p = t % l -- 3 % 10 = 3
	x = l - p -- 10 - 3 = 7
	
	if 0 <= p and p < length then
		return p
	else
		return l - p
	end
end

function mathf.cap(num, mn)
	if num > mn then
		return mn
	else
		return num
	end
end

function mathf.bot(num, mn)
	if num < mn then
		return mn
	else
		return num
	end
end

function mathf.lerp(a, b, t)
    return a * (1-t) + (b*t)
end

function mathf.clamp(v, min, max)
	if v < min then 
		return min
	elseif v > max then 
		return max
	else 
		return v 
	end
end

function mathf.clamp01(v)
	if v < 0 then 
		return 0
	elseif v > 1 then 
		return 1
	else 
		return v
	end
end

function mathf.remap(value, low1, high1, low2, high2)
    return low2 + (high2 - low2) * (value - low1) / (high1 - low1)
end

function mathf.booltoint(b)
	if b == true then
        return 1
	else
        return 0
	end
end

function mathf.round(n)
	return n % 1 >= 0.5 and math.ceil(n) or math.floor(n)
end

function mathf.round2(num, n)
  local mult = 10^(n or 0)
  return math.floor(num * mult + 0.5) / mult
end

-- VECTOR2

vector2 = {}

function vector2.new(x,y)
	local v = {}
	v.x = x or 0
	v.y = y or 0
	return v
end

function vector2.add(a, b)
	return vector2.new(a.x + b.x, a.y + b.y)
end

function vector2.mult(a, b)
	if type(a) == 'table' and type(b) == 'table' then -- Both vectors
		return vector2.new(a.x * b.x, a.y * b.y)
	elseif type(a) == 'table' and type(b) == 'number' then -- A vector
		return vector2.new(a.x * b, a.y * b)
	elseif type(a) == 'number' and type(b) == 'table' then -- B vector
		return vector2.new(a * b.x, a * b.y)
	end
end

function vector2.lerp(a, b, t)
	return vector2.new(mathf.lerp(a.x, b.x, t), mathf.lerp(a.y, b.y, t))
end

vector2.up = vector2.new(0,1)
vector2.down = vector2.new(0,-1)
vector2.right = vector2.new(1,0)
vector2.left = vector2.new(-1,0)
vector2.zero = vector2.new(0,0)