-- Platform

plat = {}
plat.plists = {}

function plat.new(list, x, y, w, h, color)

	p = {}
	
	p.x = x
	p.y = y
	p.width = w
	p.height = h
	
	p.color = color or {1,1,1}
	
	p.b = love.physics.newBody(world, p.x, p.y) 
	p.s = love.physics.newRectangleShape(p.width/2, p.height/2, p.width, p.height)
	p.f = love.physics.newFixture(p.b, p.s)
	p.f:setUserData("Ground")
	
	if plat.plists[list] == nil then
		plat.plists[list] = {}
	end
	
	table.insert(plat.plists[list], p)

end

function plat.draw(list)
	
	for k,v in ipairs(plat.plists[list]) do
		love.graphics.setColor(v.color)
		love.graphics.rectangle('fill', v.x, v.y, v.width, v.height)
	end
	
end